/****************************************************************************
 *   Copyright (C) 2010-2011 by Claas Anders "CaScAdE" Rathje               *
 *   ClaasR@thje.net                                                        *
 *   Project-URL: http://www.mylifesucks.de/oss/c-tid/                      *
 *                                                                          *
 *   This program is free software; you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation; either version 2 of the License.         *
 *                                                                          *
 *   This program is distributed in the hope that it will be useful,        *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for more details.                           *
 *                                                                          *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to the                          *
 *   Free Software Foundation, Inc.,                                        *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 *                                                                          *
 ****************************************************************************/

#include "C-TID.h"
#include "int0.h"
#include "timer0.h"

volatile uint16_t rpm = 0;

void int0_init() {
#if defined (__AVR_ATtiny84__)	
    MCUCR |= ((1 << ISC00) | (1 << ISC01)); // a rising edge on INT0 activates the interrupt
#else
    //PORTD |= (1 << PORTD2); // enable pullup on INT0 pin
    MCUCR |= ((1 << ISC00) | (1 << ISC01)); // a rising edge on INT0 activates the interrupt
#endif

}

void int0_enable() {
#if defined (__AVR_ATtiny84__)	
    GIMSK |= (1 << INT0); // External Interrupt Request 0 Enable
#else
    GICR |= (1 << INT0); // External Interrupt Request 0 Enable
#endif
    timer0_overflows = 0;
}

void int0_disable() {
#if defined (__AVR_ATtiny84__)	
    GIMSK &= ~(1 << INT0); // External Interrupt Request 0 Disble
#else
    GICR &= ~(1 << INT0); // External Interrupt Request 0 Disable
#endif
}




#if defined (__AVR_ATtiny84__)

ISR(EXT_INT0_vect) {
#else

ISR(INT0_vect) {
#endif

    //TODO: calculate RPM based on interrups
}
